#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
// #define int ll
#define pb emplace_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define size(x) int((x).size())


typedef pair<int, int> pii;


const int INF = 2e9 + 10;
const int MAXN = 1e5 + 10;

vector<vector<pii>> g;
vector<int> cost;
vector<int> ans;
vector<int> cnt; 
vector<int> mx;
bool comp(pii a, pii b) {
	return (a.second < b.second || (a.second == b.second && a.first < b.first));
}
int n, k;
void dfs(int v, int p = -1) {
	vector<pii> free;
	int res = 0;
	int mxEdge = 0;
	vector<pii> full; 
	for (auto [to, w] : g[v]) {
		if (to == p) continue;
		dfs(to, v);
		if (cnt[to] != k) free.pb(to, w);
		else full.pb(to, mx[to] - w);
	}
	sort(all(free), comp);
	sort(all(full), comp);
	for (int i = 0; i < min(k, size(free)); i++) {
		auto [to, w] = free[i];
		ans[v] += ans[to] + 1;
		cost[v] += cost[to] + w;
		mxEdge = max(mxEdge, w);
		res++;
	}
	for (int i = k; i < size(free); i++) {
		auto [to, w] = free[i];
		ans[v] += ans[to];
		cost[v] += cost[to];
	}
	for (int i = 0; i < min(k - size(free), size(full)); i++) {
		auto [to, w] = full[i];
		ans[v] += ans[to]; 
		if (w > 0) {
			mxEdge = max(mxEdge, w);
			cost[v] += cost[to] - mx[to] + w;
			res++;
		} else cost[v] += cost[to];
	}
	for (int i = max(0,k - size(free)); i < size(full); i++) {
		auto [to, w] = full[i];
		ans[v] += ans[to]; 
		cost[v] += cost[to];
	}
	cnt[v] = res;
	mx[v] =  mxEdge;

}
signed main() {
	#ifdef _ARTUR
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	cin >> n >> k;
	g.resize(n);
	mx.resize(n);
	cnt.resize(n);
	cost.resize(n, 0);
	ans.resize(n, 0);
	for (int i = 1; i < n; i++) {
		int p, w;
		cin >> p >> w;
		p--;
		g[i].pb(p, w);
		g[p].pb(i, w);
	}
	dfs(0);
	cout << ans[0] << ' ' << cost[0];
	return 0;
}
/*
8 3
1 5
1 2
1 4
2 6
2 7
2 2
1 6
*/